# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files batons.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *
from textelibre import *
sys.path.append("../Supplements/Pro-1varstat/")
from supp_batons import *





class Batons:



    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('batons.glade')
        self.initialisation=True
        self.radiobuttonMetapost = interface.get_object("radiobuttonMetapost")
        self.radiobuttonAsymptote = interface.get_object("radiobuttonAsymptote")
        self.entryListeValeurs = interface.get_object("entryListeValeurs")
        self.entryListeEffectifs = interface.get_object("entryListeEffectifs")
        self.entryXmin = interface.get_object("entryXmin")
        self.entryXmax = interface.get_object("entryXmax")
        self.entryYmin = interface.get_object("entryYmin")
        self.entryYmax = interface.get_object("entryYmax")
        self.entryUx = interface.get_object("entryUx")
        self.entryUy = interface.get_object("entryUy")
        self.entryLy = interface.get_object("entryLy")
        self.entryGy = interface.get_object("entryGy")
        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")
        self.labelEntete = interface.get_object("labelEntete")
        self.checkbuttonTitreGauche = interface.get_object("checkbuttonTitreGauche")
        self.checkbuttonTitreCentre = interface.get_object("checkbuttonTitreCentre")
        self.checkbuttonTitreDroite = interface.get_object("checkbuttonTitreDroite")
        self.checkbuttonCouleurBoite = interface.get_object("checkbuttonCouleurBoite")
        self.checkbuttonEcartType = interface.get_object("checkbuttonEcartType")
        self.checkbuttonTexteLibre = interface.get_object("checkbuttonTexteLibre")
        self.entryTitreGauche = interface.get_object("entryTitreGauche")
        self.entryTitreCentre = interface.get_object("entryTitreCentre")
        self.entryTitreDroite = interface.get_object("entryTitreDroite")    
        self.comboboxCouleur = interface.get_object("comboboxCouleur")  
        self.radiobuttonEC1 = interface.get_object("radiobuttonEC1")
        self.radiobuttonEC2 = interface.get_object("radiobuttonEC2")
        self.radiobuttonEC3 = interface.get_object("radiobuttonEC3")
        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        #fenêtre textlibre
        self.TL=Textelibre(self)
        self.TL.windowTL.set_title("Textes supplémentaires")
        self.TL.windowTL.hide()
        
        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        #Couleur par défaut : orange
        self.comboboxCouleur.set_active(4)
        #désactivation
        self.comboboxCouleur.set_sensitive(False)
        self.radiobuttonEC1.set_sensitive(False)
        self.radiobuttonEC2.set_sensitive(False)
        self.radiobuttonEC3.set_sensitive(False)
        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))

        self.entryTitreGauche.set_sensitive(False)
        self.entryTitreCentre.set_sensitive(False)
        self.entryTitreDroite.set_sensitive(False)
        
        self.initialisation=False


    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowBatons_destroy(self, widget):
        gtk.main_quit()

    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        Texte_Code="\\begin{pro-batons}{1}\n"
        Texte_Code=Texte_Code+"["
        ListeValeurs=self.entryListeValeurs.get_text()
        ListeValeurs=ListeValeurs.replace('\\','@')
        ListeEffectifs=self.entryListeEffectifs.get_text()
        ListeEffectifs=ListeEffectifs.replace('\\','@')
        Xmin=self.entryXmin.get_text()
        Xmin=Xmin.replace('\\','@')
        Xmax=self.entryXmax.get_text()
        Xmax=Xmax.replace('\\','@')
        Ymin=self.entryYmin.get_text()
        Ymin=Ymin.replace('\\','@')
        Ymax=self.entryYmax.get_text()
        Ymax=Ymax.replace('\\','@')
        Ux=self.entryUx.get_text()
        Ux=Ux.replace('\\','@')
        Uy=self.entryUy.get_text()
        Uy=Uy.replace('\\','@')
        Ly=self.entryLy.get_text()
        Ly=Ly.replace('\\','@')
        Gy=self.entryGy.get_text()
        Gy=Gy.replace('\\','@') 
        Texte_Code=Texte_Code+ListeValeurs+"],\n"
        Texte_Code=Texte_Code+"["+ListeEffectifs+"],\n"
        Texte_Code=Texte_Code+Xmin+","+Xmax+","+Ymin+","+Ymax+",\n"
        Texte_Code=Texte_Code+Ux+","+Uy+",\n"
        Texte_Code=Texte_Code+Ly+",\n"
        Texte_Code=Texte_Code+Gy+",\n"
        Texte_Code=Texte_Code+"// ----------------- début des options\n"
        Texte_Code=Texte_Code+"[\n"
        Options=self.traiter_options()
        Texte_Code=Texte_Code+Options
        Texte_Code=Texte_Code+"]\n"
        Texte_Code=Texte_Code+"// ----------------- fin des options\n"
        Texte_Code=Texte_Code+"\\end{pro-batons}"
        ecrire_texte_textview(Texte_Code,text_view)




    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition
    #-------------------------------------------------------------      
    def on_entryListeValeurs_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryListeEffectifs_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryXmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryXmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryUx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryUy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryLy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryGy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False 
        
    def on_checkbuttonCouleurBoite_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonCouleurBoite.get_active()==True:
            self.comboboxCouleur.set_sensitive(True)
        else:
            self.comboboxCouleur.set_sensitive(False)       
        self.Etat_Compilation=False
    
    def on_comboboxCouleur_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_checkbuttonEcartType_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonEcartType.get_active()==True:
            self.radiobuttonEC1.set_sensitive(True)
            self.radiobuttonEC2.set_sensitive(True)
            self.radiobuttonEC3.set_sensitive(True)
        else:
            self.radiobuttonEC1.set_sensitive(False)
            self.radiobuttonEC2.set_sensitive(False)
            self.radiobuttonEC3.set_sensitive(False)    
        self.Etat_Compilation=False
        
    def on_checkbuttonTexteLibre_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTexteLibre.get_active()==True:
            self.TL.windowTL.show_all()
        else:
            self.TL.windowTL.hide()
        self.Etat_Compilation=False
        


    #-------------------------------------------------------------
    # Mise à jour du label du nom de paquet à utiliser
    #-------------------------------------------------------------          
    def on_radiobuttonMetapost_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-1varstat}")
        self.Etat_Compilation=False
        
    def on_radiobuttonAsymptote_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-asy-1varstat}")      
        self.Etat_Compilation=False
        

    #-------------------------------------------------------------
    # Traitement des options    
    #-------------------------------------------------------------  
    def traiter_options(self):
        Options=""
        if self.checkbuttonTitreGauche.get_active()==True :
           Options="[\"titre-gauche\",\""
           TitreGauche=self.entryTitreGauche.get_text()
           TitreGauche=traiter_texte(TitreGauche)
           Options=Options+TitreGauche
           Options=Options+"\"],\n"
           
        if self.checkbuttonTitreCentre.get_active()==True :
           Options=Options+"[\"titre-centre\",\""
           TitreCentre=self.entryTitreCentre.get_text()
           TitreCentre=traiter_texte(TitreCentre)
           Options=Options+TitreCentre
           Options=Options+"\"],\n" 
           
        if self.checkbuttonTitreDroite.get_active()==True :
           Options=Options+"[\"titre-droite\",\""
           TitreDroite=self.entryTitreDroite.get_text()
           TitreDroite=traiter_texte(TitreDroite)
           Options=Options+TitreGauche
           
        if self.checkbuttonCouleurBoite.get_active()==True :
           Options=Options+"[\"couleur-dessin\",\""
           Couleur=self.comboboxCouleur.get_active_text()
           Texte_Couleur=Nom_Couleur(Couleur)
           Options=Options+Texte_Couleur  
           Options=Options+"\"],\n"
           
        if self.checkbuttonEcartType.get_active()==True :
           Options=Options+"[\"ecart-type\",\""
           if self.radiobuttonEC1.get_active()==True:
            Nbecart="1"
           elif self.radiobuttonEC2.get_active()==True: 
            Nbecart="2"
           else:
            Nbecart="3"
           Options=Options+Nbecart  
           Options=Options+"\"],\n"        
        Options=Options+self.TL.Texte_Libre
        Options=Options+"[\"rien\"]\n"
        return Options

    #-------------------------------------------------------------
    # Mise à jour suite au traitement des options   
    #-------------------------------------------------------------          
    def on_checkbuttonTitreGauche_clicked(self,widget):
        if self.checkbuttonTitreGauche.get_active()==False :
            self.entryTitreGauche.set_sensitive(False)
        else :
            self.entryTitreGauche.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_checkbuttonTitreCentre_clicked(self,widget):
        if self.checkbuttonTitreCentre.get_active()==False :
            self.entryTitreCentre.set_sensitive(False)
        else :
            self.entryTitreCentre.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
            
    def on_checkbuttonTitreDroite_clicked(self,widget):
        if self.checkbuttonTitreDroite.get_active()==False :
            self.entryTitreDroite.set_sensitive(False)
        else :
            self.entryTitreDroite.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_entryTitreGauche_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_entryTitreCentre_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 

    def on_entryTitreDroite_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
    
    def on_radiobuttonEC1_clicked(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False

    def on_radiobuttonEC2_clicked(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
        
    def on_radiobuttonEC3_clicked(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
            
        

    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        if self.radiobuttonMetapost.get_active()==True:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-1varstat}")  
            compiler("mp")
            self.Etat_Compilation=True
            afficher("mp","batons1")
        else:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-asy-1varstat}")  
            compiler("asy")
            self.Etat_Compilation=True
            afficher("asy","batons1")
        self.progressbar.set_text("")
        
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeGraphique_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_codegraphique("mp","batons1",self.Etat_Compilation)
        else:
            afficher_codegraphique("asy","batons1",self.Etat_Compilation)

    #-------------------------------------------------------------
    # Affichage de l'image  
    #-------------------------------------------------------------  
    def on_buttonPdf_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_imagepng("mp","batons1",self.Etat_Compilation)
        else:
            afficher_imagepng("asy","batons1",self.Etat_Compilation)            


            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Batons()
    gtk.main()

