# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files courbebezier.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *
from textelibre import *
from pointlibre import *
sys.path.append("../Supplements/Pro-courbes/")
from supp_courbebezier import *



class Courbebezier:



    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('courbebezier.glade')
        self.initialisation=True
        self.radiobuttonMetapost = interface.get_object("radiobuttonMetapost")
        self.radiobuttonAsymptote = interface.get_object("radiobuttonAsymptote")
        self.entryF1 = interface.get_object("entryF1")
        self.entryF2 = interface.get_object("entryF2")
        self.entryF3 = interface.get_object("entryF3")
        self.entryF4 = interface.get_object("entryF4")
        self.entryCB1 = interface.get_object("entryCB1")
        self.entryCB2 = interface.get_object("entryCB2")
        self.entryCB3 = interface.get_object("entryCB3")
        self.entryCB4 = interface.get_object("entryCB4")    
        self.entryXmin = interface.get_object("entryXmin")
        self.entryXmax = interface.get_object("entryXmax")
        self.entryYmin = interface.get_object("entryYmin")
        self.entryYmax = interface.get_object("entryYmax")
        self.entryLargeur = interface.get_object("entryLargeur")
        self.entryHauteur = interface.get_object("entryHauteur")
        self.entryLx = interface.get_object("entryLx")
        self.entryLy = interface.get_object("entryLy")
        self.entryGx = interface.get_object("entryGx")
        self.entryGy = interface.get_object("entryGy")
        self.entryCT = interface.get_object("entryCT")
        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")
        self.labelEntete = interface.get_object("labelEntete")
        self.checkbuttonTitreGauche = interface.get_object("checkbuttonTitreGauche")
        self.checkbuttonTitreCentre = interface.get_object("checkbuttonTitreCentre")
        self.checkbuttonTitreDroite = interface.get_object("checkbuttonTitreDroite")
        self.checkbuttonF2 = interface.get_object("checkbuttonF2")
        self.checkbuttonF3 = interface.get_object("checkbuttonF3")
        self.checkbuttonF4 = interface.get_object("checkbuttonF4")
        self.checkbuttonCB = interface.get_object("checkbuttonCB")
        self.checkbuttonPoints = interface.get_object("checkbuttonPoints")
        self.checkbuttonBase = interface.get_object("checkbuttonBase")
        self.checkbuttonGrille = interface.get_object("checkbuttonGrille")
        self.checkbuttonPointLibre = interface.get_object("checkbuttonPointLibre")
        self.checkbuttonTexteLibre = interface.get_object("checkbuttonTexteLibre")
        self.entryTitreGauche = interface.get_object("entryTitreGauche")
        self.entryTitreCentre = interface.get_object("entryTitreCentre")
        self.entryTitreDroite = interface.get_object("entryTitreDroite")    
        self.comboboxTypeGrille = interface.get_object("comboboxTypeGrille")    
        self.comboboxCouleurGrille = interface.get_object("comboboxCouleurGrille")
        self.comboboxCouleurF1 = interface.get_object("comboboxCouleurF1")
        self.comboboxCouleurF2 = interface.get_object("comboboxCouleurF2")
        self.comboboxCouleurF3 = interface.get_object("comboboxCouleurF3")
        self.comboboxCouleurF4 = interface.get_object("comboboxCouleurF4")
        

        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        #fenêtre textlibre
        self.TL=Textelibre(self)
        self.TL.windowTL.set_title("Textes supplémentaires")
        self.TL.windowTL.hide()
        
        #fenêtre pointlibre
        self.PL=Pointlibre(self)
        self.PL.windowPL.set_title("Points supplémentaires")
        self.PL.windowPL.hide()

        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        
        #désactivation
        self.entryF2.set_sensitive(False)
        self.entryF3.set_sensitive(False)
        self.entryF4.set_sensitive(False)
        
        self.comboboxCouleurF2.set_sensitive(False)
        self.comboboxCouleurF3.set_sensitive(False)
        self.comboboxCouleurF4.set_sensitive(False)

        
        self.entryCB1.set_sensitive(False)
        self.entryCB2.set_sensitive(False)
        self.entryCB3.set_sensitive(False)
        self.entryCB4.set_sensitive(False)
        

        self.entryTitreGauche.set_sensitive(False)
        self.entryTitreCentre.set_sensitive(False)
        self.entryTitreDroite.set_sensitive(False)
        
        self.comboboxTypeGrille.set_sensitive(False)
        self.comboboxCouleurGrille.set_sensitive(False)
        
        #valeur par défaut
        self.comboboxTypeGrille.set_active(0)
        self.comboboxCouleurGrille.set_active(11)
        self.comboboxCouleurF1.set_active(1)
        self.comboboxCouleurF2.set_active(1)
        self.comboboxCouleurF3.set_active(1)
        self.comboboxCouleurF4.set_active(1)
        
        
        self.initialisation=False


    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowCourbebezier_destroy(self, widget):
        gtk.main_quit()

    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        Texte_Code="\\begin{pro-courbebezier}{1}\n"
        Texte_Code=Texte_Code+"[\n"
        #---------------liste des cordonnées
        F1=self.entryF1.get_text()
        Liste_Points="["+F1+"]"
        if self.checkbuttonF2.get_active()==True:   
            F2=self.entryF2.get_text()
            Liste_Points=Liste_Points+",\n"
            Liste_Points=Liste_Points+"["+F2+"]"
        if self.checkbuttonF3.get_active()==True:   
            F3=self.entryF3.get_text()
            Liste_Points=Liste_Points+",\n"
            Liste_Points=Liste_Points+"["+F3+"]"
        if self.checkbuttonF4.get_active()==True:   
            F4=self.entryF4.get_text()
            Liste_Points=Liste_Points+",\n"
            Liste_Points=Liste_Points+"["+F4+"]"
        #---------------liste des cordonnées
        Couleur=self.comboboxCouleurF1.get_active_text()
        Couleur=Nom_Couleur(Couleur)
        Liste_Couleurs="[\""+Couleur+"\""
        if self.checkbuttonF2.get_active()==True:   
            Couleur=self.comboboxCouleurF2.get_active_text()
            Couleur=Nom_Couleur(Couleur)
            Liste_Couleurs=Liste_Couleurs+",\""+Couleur+"\""

        if self.checkbuttonF3.get_active()==True:   
            Couleur=self.comboboxCouleurF3.get_active_text()
            Couleur=Nom_Couleur(Couleur)
            Liste_Couleurs=Liste_Couleurs+",\""+Couleur+"\""

        if self.checkbuttonF4.get_active()==True:   
            Couleur=self.comboboxCouleurF4.get_active_text()
            Couleur=Nom_Couleur(Couleur)
            Liste_Couleurs=Liste_Couleurs+",\""+Couleur+"\""
        Liste_Couleurs=Liste_Couleurs+"],\n"

        
        Texte_Code=Texte_Code+Liste_Points
        Texte_Code=Texte_Code+"\n"  
        Texte_Code=Texte_Code+"],\n"
        Xmin=self.entryXmin.get_text()
        Xmin=Xmin.replace('\\','@')
        Xmax=self.entryXmax.get_text()
        Xmax=Xmax.replace('\\','@')
        Ymin=self.entryYmin.get_text()
        Ymin=Ymin.replace('\\','@')
        Ymax=self.entryYmax.get_text()
        Ymax=Ymax.replace('\\','@')
        Largeur=self.entryLargeur.get_text()
        Largeur=Largeur.replace('\\','@')
        Hauteur=self.entryHauteur.get_text()
        Hauteur=Hauteur.replace('\\','@')
        Lx=self.entryLx.get_text()
        Lx=Lx.replace('\\','@')
        Ly=self.entryLy.get_text()
        Ly=Ly.replace('\\','@')
        Gx=self.entryGx.get_text()
        Gx=Gx.replace('\\','@') 
        Gy=self.entryGy.get_text()
        Gy=Gy.replace('\\','@') 
        CT=self.entryCT.get_text()
        CT=CT.replace('\\','@')     
        Texte_Code=Texte_Code+Xmin+","+Xmax+","+Ymin+","+Ymax+",\n"
        Texte_Code=Texte_Code+Largeur+","+Hauteur+",\n"
        Texte_Code=Texte_Code+Lx+","+Ly+",\n"
        Texte_Code=Texte_Code+Gx+","+Gy+",\n"
        Texte_Code=Texte_Code+CT+",\n"
        Texte_Code=Texte_Code+Liste_Couleurs +"\n"
        Texte_Code=Texte_Code+"// ----------------- début des options\n"
        Texte_Code=Texte_Code+"[\n"
        Options=self.traiter_options()
        Texte_Code=Texte_Code+Options
        Texte_Code=Texte_Code+"]\n"
        Texte_Code=Texte_Code+"// ----------------- fin des options\n"
        Texte_Code=Texte_Code+"\\end{pro-courbebezier}"
        ecrire_texte_textview(Texte_Code,text_view)




    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition
    #-------------------------------------------------------------      
    
    def on_entryF1_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryF2_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryF3_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryF4_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
            
    def on_entryCB1_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryCB2_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryCB3_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryCB4_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_comboboxCouleurF1_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False     
            
    def on_comboboxCouleurF2_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False     
            
    def on_comboboxCouleurF3_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False     
            
    def on_comboboxCouleurF4_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False     
            
        
    def on_entryXmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryXmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryLargeur_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryHauteur_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryLx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryLy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryGx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False
        
    def on_entryGy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False 
        
    def on_entryCT_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False     
    
        
    def on_checkbuttonTexteLibre_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTexteLibre.get_active()==True:
            self.TL.windowTL.show_all()
        else:
            self.TL.windowTL.hide()
        self.Etat_Compilation=False
        
    def on_checkbuttonPointLibre_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonPointLibre.get_active()==True:
            self.PL.windowPL.show_all()
        else:
            self.PL.windowPL.hide()
        self.Etat_Compilation=False
        
    def on_checkbuttonCB_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonCB.get_active()==True:
            self.entryCB1.set_sensitive(True)
            if self.checkbuttonF2.get_active()==True:
                self.entryCB2.set_sensitive(True)
            if self.checkbuttonF3.get_active()==True:
                self.entryCB3.set_sensitive(True)
            if self.checkbuttonF4.get_active()==True:
                self.entryCB4.set_sensitive(True)       
        else:
            self.entryCB1.set_sensitive(False)
            self.entryCB2.set_sensitive(False)
            self.entryCB3.set_sensitive(False)
            self.entryCB4.set_sensitive(False)
        self.Etat_Compilation=False
        

    def on_checkbuttonF2_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonF2.get_active()==True:
            self.entryF2.set_sensitive(True)
            if self.checkbuttonCB.get_active()==True:
                self.entryCB2.set_sensitive(True)
            self.comboboxCouleurF2.set_sensitive(True)
        else:
            self.entryF2.set_sensitive(False)
            self.entryCB2.set_sensitive(False)
            self.comboboxCouleurF2.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_checkbuttonF3_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonF3.get_active()==True:
            self.entryF3.set_sensitive(True)
            if self.checkbuttonCB.get_active()==True:
                self.entryCB3.set_sensitive(True)
            self.comboboxCouleurF3.set_sensitive(True)
        else:
            self.entryF3.set_sensitive(False)
            self.entryCB3.set_sensitive(False)
            self.comboboxCouleurF3.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_checkbuttonF4_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonF4.get_active()==True:
            self.entryF4.set_sensitive(True)
            if self.checkbuttonCB.get_active()==True:
                self.entryCB4.set_sensitive(True)
            self.comboboxCouleurF4.set_sensitive(True)
        else:
            self.entryF4.set_sensitive(False)
            self.entryCB4.set_sensitive(False)
            self.comboboxCouleurF4.set_sensitive(False)
        self.Etat_Compilation=False
        
        

            


    #-------------------------------------------------------------
    # Mise à jour du label du nom de paquet à utiliser
    #-------------------------------------------------------------          
    def on_radiobuttonMetapost_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-courbes}")
        self.Etat_Compilation=False
        
    def on_radiobuttonAsymptote_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-asy-courbes}")       
        self.Etat_Compilation=False
        

    #-------------------------------------------------------------
    # Traitement des options    
    #-------------------------------------------------------------  
    def traiter_options(self):
        Options=""
        if self.checkbuttonTitreGauche.get_active()==True :
           Options="[\"titre-gauche\",\""
           TitreGauche=self.entryTitreGauche.get_text()
           TitreGauche=traiter_texte(TitreGauche)
           Options=Options+TitreGauche
           Options=Options+"\"],\n"
           
        if self.checkbuttonTitreCentre.get_active()==True :
           Options=Options+"[\"titre-centre\",\""
           TitreCentre=self.entryTitreCentre.get_text()
           TitreCentre=traiter_texte(TitreCentre)
           Options=Options+TitreCentre
           Options=Options+"\"],\n" 
           
        if self.checkbuttonTitreDroite.get_active()==True :
           Options=Options+"[\"titre-droite\",\""
           TitreDroite=self.entryTitreDroite.get_text()
           TitreDroite=traiter_texte(TitreDroite)
           Options=Options+TitreGauche
           
        if self.checkbuttonPoints.get_active()==True :
           Options=Options+"[\"croix\"],\n"   
           
        if self.checkbuttonBase.get_active()==True :
           Options=Options+"[\"base\"],\n"
           
        if self.checkbuttonCB.get_active()==True :
            Options=Options+"[\"courbure\","   
            #---------------liste des courbures
            CB1=self.entryCB1.get_text()
            Liste_Courbures="["+CB1+"]"
            if self.checkbuttonF2.get_active()==True:   
                CB=self.entryCB2.get_text()
                Liste_Courbures=Liste_Courbures+",["+CB+"]"
            if self.checkbuttonF3.get_active()==True:   
                CB=self.entryCB3.get_text()
                Liste_Courbures=Liste_Courbures+",["+CB+"]"
            if self.checkbuttonF4.get_active()==True:   
                CB=self.entryC4.get_text()
                Liste_Courbures=Liste_Courbures+",["+CB+"]"
            Liste_Courbures=Liste_Courbures+"],\n"
            Options=Options+Liste_Courbures


           
        if self.checkbuttonGrille.get_active()==True :
            CouleurGrille=self.comboboxCouleurGrille.get_active_text()
            CouleurGrille=Nom_Couleur(CouleurGrille)
            TypeGrille=self.comboboxTypeGrille.get_active_text() 
            if TypeGrille=="Pleine":
                Option_Grille="plein"
            elif TypeGrille=="Pointillée":
                Option_Grille="pointille"
            elif TypeGrille=="Hachurée":
                Option_Grille="hachure"     
            else:
                Option_Grille="millimetre"  
            Options=Options+"[\"grille\",\""+Option_Grille+"\",\""+CouleurGrille+"\"],\n"       

        Options=Options+self.PL.Texte_Point_Libre
        Options=Options+self.TL.Texte_Libre
        Options=Options+"[\"rien\"]\n"
        return Options

    #-------------------------------------------------------------
    # Mise à jour suite au traitement des options   
    #-------------------------------------------------------------          
    def on_checkbuttonTitreGauche_clicked(self,widget):
        if self.checkbuttonTitreGauche.get_active()==False :
            self.entryTitreGauche.set_sensitive(False)
        else :
            self.entryTitreGauche.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_checkbuttonTitreCentre_clicked(self,widget):
        if self.checkbuttonTitreCentre.get_active()==False :
            self.entryTitreCentre.set_sensitive(False)
        else :
            self.entryTitreCentre.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
            
    def on_checkbuttonTitreDroite_clicked(self,widget):
        if self.checkbuttonTitreDroite.get_active()==False :
            self.entryTitreDroite.set_sensitive(False)
        else :
            self.entryTitreDroite.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_entryTitreGauche_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_entryTitreCentre_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 

    def on_entryTitreDroite_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
        
    def on_checkbuttonPoints_clicked(self,widget):
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False 
        
    def on_checkbuttonBase_clicked(self,widget):
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_checkbuttonGrille_clicked(self,widget):
        if self.checkbuttonGrille.get_active()==False :
            self.comboboxTypeGrille.set_sensitive(False)
            self.comboboxCouleurGrille.set_sensitive(False)
        else :
            self.comboboxTypeGrille.set_sensitive(True)
            self.comboboxCouleurGrille.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False 
            
    def on_comboboxTypeGrille_changed(self,widget):
        if self.comboboxTypeGrille.get_active_text()=="Millimétrée":
            self.comboboxCouleurGrille.set_active(11)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurGrille_changed(self,widget):
        if self.comboboxTypeGrille.get_active_text()=="Millimétrée":
            self.comboboxCouleurGrille.set_active(11)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False 
            
        

    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        if self.radiobuttonMetapost.get_active()==True:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-courbes}")   
            compiler("mp")
            self.Etat_Compilation=True
            afficher("mp","courbebezier1")
        else:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-asy-courbes}")   
            compiler("asy")
            self.Etat_Compilation=True
            afficher("asy","courbebezier1")
        self.progressbar.set_text("")
        
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeGraphique_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_codegraphique("mp","courbebezier1",self.Etat_Compilation)
        else:
            afficher_codegraphique("asy","courbebezier1",self.Etat_Compilation)

    #-------------------------------------------------------------
    # Affichage de l'image  
    #-------------------------------------------------------------  
    def on_buttonPdf_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_imagepng("mp","courbebezier1",self.Etat_Compilation)
        else:
            afficher_imagepng("asy","courbebezier1",self.Etat_Compilation)          


            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Courbebezier()
    gtk.main()

